// variables
var canvas, ctx;
var imgObj;

function changeSinContrast(par) {
    var dPow = 4;
    var iMid = 128;

    if (par > 0 && par < iMid) {
        par = Math.sin( Math.PI * ((90-(par/dPow)) / 180)) * par;
    } else if (par >= iMid) {
        par = Math.sin( Math.PI * ((90-((256-par))/dPow)/180) ) * par;
    }
    return par;
}

function processHrdEffect() {
    // get current image data
    var imageData = ctx.getImageData(0,0,canvas.width,canvas.height);

    var iMid = 128;
    var dPow = 3;

    for (var i=0; i < imageData.data.length; i+=4) {
        imageData.data[i+0] = changeSinContrast(imageData.data[i+0]);
        imageData.data[i+1] = changeSinContrast(imageData.data[i+1]);
        imageData.data[i+2] = changeSinContrast(imageData.data[i+2]);
    }

    // put image data back to context
    ctx.putImageData(imageData, 0, 0);
};

$(function () {

    // create canvas and context objects
    canvas = document.getElementById('source');
    ctx = canvas.getContext('2d');

    // load source image
    imgObj = new Image();
    imgObj.onload = function () {

        // draw image
        ctx.drawImage(this, 0, 0, this.width, this.height, 0, 0, canvas.width, canvas.height);
    }
    imgObj.src = 'images/pic1.jpg';

    // different onclick handlers
    var iCur = 1;
    $('#next').click(function () {
        iCur++;
        if (iCur > 6) iCur = 1;
        imgObj.src = 'images/pic' + iCur + '.jpg';
    });
    $('#sepia').click(function () {
        processHrdEffect();
    });
    $('#toImage').click(function () {
        $('#img').attr('src', canvas.toDataURL('image/jpeg'));
    });
});